<script>

import ExcelWorker from '../excel_loader.js?worker'

import { TreeNode } from '../library.js'
import { createEventDispatcher } from 'svelte'
const dispatch = createEventDispatcher()

export let root = {}

let busy_mode = false


async function catchContent(evt) {
    const data = evt.dataTransfer
    evt.preventDefault()
    if (data.getData("internal_drop") && !root.marked) {
        //
        // перетаскивание внутри каталога
        //
        let child_tree = JSON.parse(data.getData("internal_drop"))
        root.appendTree(child_tree)
        dispatch('cleanup', true)
    } else {
        //
        // получение контента из файла
        //
        let file = null
        if (data.items && data.items[0].kind === "file") {
            file = data.items[0].getAsFile()
        } else {
            if (data.files) file = data.files[0]
        }
        if (file) {
            if (file.name.match(/(.xlsx?)/gm)) {
                console.log("load excel file")
                let xlw = new ExcelWorker()
                busy_mode = true
                xlw.onmessage = (evt) => {
                    root.content = evt.data
                    busy_mode = false
                    console.log("data loaded")
                }
                xlw.postMessage(file)
            } else {
                const file_text = await file.text()
                root.appendIndentedStructure(file_text.split("\n"))
                root.unfolded = true
            }
        }
    }
    dispatch('update', true)
}

function startDragging(evt) {
    evt.dataTransfer.dropEffect = "move"
    evt.dataTransfer.effectAllowed = "move"
    evt.dataTransfer.setData("internal_drop", JSON.stringify(root))
    root.setMarked(true)
}

function switchSelection() {
    root.makeSelection(!root.selected)
    dispatch('update', true)
}

function folderClick(evt) {
    if (evt.ctrlKey) {
        root.appendNodes(new TreeNode("Новая Папка"))
        dispatch('update', true)
    } else {
        if (evt.altKey) {
            root.mode = root.mode == "container" ? "folder" : "container"
        } else {
            root.unfolded = !root.unfolded
        }
    }
}


</script>
<!--
<li on:dragover|preventDefault on:dragenter|preventDefault on:drop={catchContent}>
    <span class="node_name">{root.name}</span>
</li>
-->
{#if root.enabled}
<li on:dragover|preventDefault 
    on:dragenter|preventDefault 
    on:drop={catchContent}
    on:dragstart={startDragging}
    draggable="true">
    
    <div class="side_line"></div>
    {#if root.mode == "container"}
        {#if !busy_mode}
            <button on:click={folderClick} style="background: peachpuff; border: solid orange 1px">
                {#if root.content.length > 0}
                    <span>T</span>
                {/if}
            </button>
        {:else}
            <button class="excel_pulsar">
            </button>
        {/if}

    {:else}
        <button on:click={folderClick}>
            <span class="btn_add">{#if root.unfolded}-{:else}+{/if}</span>
        </button>
    {/if}
    <button on:click={switchSelection} 
        style="border-color: {root.selected ? 'orange' : 'grey'}">
    </button>
    <input class="name" style="color: {root.selected ? 'orange' : 'black'}" bind:value={root.name}/>
</li>

{#if root.children && root.unfolded && root.mode == "folder"}
<ul>
    {#each root.children as child}
       <svelte:self root={child} on:update on:cleanup/>
    {/each}
</ul>
{/if}
{/if}

<style>
.name {
    position: relative;
	font-size: 12px;
	left: 5px;
    top: 8px;
    margin-bottom: 0px;
    transition: 0.2s;
    border: none;
    width: 100%;
    background: none;
}

.name:focus {
    outline: 0;
}

li {
    display: flex;
    height: 27px;
    border-left: dashed grey 1px;
    /* border: solid black 1px; */
	padding: 0px;
}

ul {
    list-style-type: none;
    padding-left: 26px;
    border-left: dashed grey 1px;
}

ul:last-child {
    border: none;
}

button {
    padding: 0px;
    width: 16px;
    height: 16px;
    border-radius: 2px;
    border-color: grey;
    margin: 0px;
    position: relative;
    top: 13px;
    border: solid grey 1px;
}

button:focus {
    outline: 0;
}

button ~ button {
    margin-left: 3px;
    background: none;
}

li:last-of-type {
    border-left: none;
}

.side_line {
    width: 20px;
	height: 20px;
	border-bottom: dashed grey 1px;
	display: inline-block;
    /* background: whitesmoke; */
    margin: 0px;
}
	
li:last-of-type .side_line {
    border-left: dashed grey 1px
}


.excel_pulsar {
  animation-name: load-pulse;
  animation-duration: 0.5s;
  animation-iteration-count: infinite;
  animation-timing-function: linear;
}

@keyframes load-pulse {
    0% { background: white; }
    50% { background: orange; }
    100% { background: white; }
}

</style>